﻿// WinRTComponent.cpp
#include "pch.h"
#include "CalcView.h"

using namespace Calculator::View;

CalcView::CalcView()  :
	presentationModel_(new CalculatorPresentationModel())
{
	presentationModel_->ClickedClear();
}

String^ CalcView::number_click(int buttonLabel)
{
	presentationModel_->ClickedNumber(buttonLabel);
	return get_display();
}

String^ CalcView::clear_click()
{
	presentationModel_->ClickedClear();
	return get_display();
}

String^ CalcView::divide_click()
{
	presentationModel_->ClickedOperator(OpDivide);
	return get_display();
}

String^ CalcView::equal_click()
{
	presentationModel_->ClickedOperator(OpNone);
	return get_display();
}

String^ CalcView::minus_click()
{
	presentationModel_->ClickedOperator(OpSubtract);
	return get_display();
}

String^ CalcView::plus_click()
{
	presentationModel_->ClickedOperator(OpAdd);
	return get_display();
}

String^ CalcView::multiply_click()
{
	presentationModel_->ClickedOperator(OpMultiply);
	return get_display();
}

String^ CalcView::get_display()
{
	return (presentationModel_->GetErrorState() != ErrNone) ?
		L"ERROR!" :
		safe_cast<int64_t>(presentationModel_->GetValue()).ToString();
}