﻿// For an introduction to the Blank template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232509
(function () {
    "use strict";

    var app = WinJS.Application;
    var activation = Windows.ApplicationModel.Activation;
    WinJS.strictProcessing();

    app.onactivated = function (args) {
        if (args.detail.kind === activation.ActivationKind.launch) {
            if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
                // TODO: This application has been newly launched. Initialize
                // your application here.
            } else {
                // TODO: This application has been reactivated from suspension.
                // Restore application state here.
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    app.oncheckpoint = function (args) {
        // TODO: This application is about to be suspended. Save any state
        // that needs to persist across suspensions here. You might use the
        // WinJS.Application.sessionState object, which is automatically
        // saved and restored across suspension. If you need to complete an
        // asynchronous operation before your application is suspended, call
        // args.setPromise().
    };

    app.start();
})();

var nativeBridge = new Calculator.View.CalcView();

function Key_Press() {
    var keyCode = String.fromCharCode(window.event.keyCode);

    switch (keyCode) {
        case 'c':
        case 'C':
            display_.textContent = nativeBridge.clear_click();
            break;

        case '/':
            display_.textContent = nativeBridge.divide_click();
            break;
        case '+':
            display_.textContent = nativeBridge.plus_click();
            break;
        case '-':
            display_.textContent = nativeBridge.minus_click();
            break;
        case '*':
            display_.textContent = nativeBridge.multiply_click();
            break;
        case '=':
        case ' ':
            display_.textContent = nativeBridge.equal_click();
            break;

        default:
            if (keyCode >= '0' && keyCode <= '9')
                display_.textContent = nativeBridge.number_click(keyCode - '0');
            break;
    }
}

function Number_Click(num) {
    display_.textContent = nativeBridge.number_click(num);
}

function Clear_Click() {
    display_.textContent = nativeBridge.clear_click();
}

function Divide_Click() {
    display_.textContent = nativeBridge.divide_click();
}

function Equal_Click() {
    display_.textContent = nativeBridge.equal_click();
}

function Minus_Click() {
    display_.textContent = nativeBridge.minus_click();
}

function Plus_Click() {
    display_.textContent = nativeBridge.plus_click();
}

function Multiply_Click() {
    display_.textContent = nativeBridge.multiply_click();
}