﻿//
// MainPage.xaml.h
// Declaration of the MainPage class.
//

#pragma once

#include <memory>
#include "MainPage.g.h"
#include "CalculatorPresentationModel.h"

using namespace std;
using namespace Calculator::View;

namespace XamlCalc
{
	class CalcView : public ICalculatorView 
	{
	public:
		CalcView() {}
		CalcView(MainPage^);
		void UpdateDisplay();
	private:
		MainPage^ page_;
	};

	/// <summary>
	/// An empty page that can be used on its own or navigated to within a Frame.
	/// </summary>
	public ref class MainPage sealed
	{
	public:
		MainPage();
		void UpdateDisplay();

	protected:
		virtual void OnNavigatedTo(Windows::UI::Xaml::Navigation::NavigationEventArgs^ e) override;

	private:
		CalcView view_;
		unique_ptr<CalculatorPresentationModel> presentationModel_;

		void Page_Loaded(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void Key_Press(Platform::Object^ sender, Windows::UI::Core::KeyEventArgs^ e);
		void Number_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void Clear_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void Divide_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void Equal_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void Minus_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void Plus_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void Multiply_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
	};
}
